/* script for validating that the token is present. If not, login page is loaded */

//alert("credentials page");

var token = readCookie(TOKEN_COOKIE_NAME);

if(token==null) {
  //alert("token is null. redirecting to login page");
  loadPage( LOGIN_PAGE);
}


$(document).ready(onReady);

function onReady() {
  
  document.addEventListener("pause", onPause, false);
  
  document.addEventListener("resume", onResume, false);
  
} 

function onPause(){
  //check if the user needs to be logged out
  //log him out
  
  var stayLoggedCookie = readCookie(STAY_LOGGED_COOKIE_NAME);
  //alert("stayLoggedCookie = " + stayLoggedCookie);
  
  if(stayLoggedCookie==null) {
    logout();
  } else{
    //refresh the token and the stay logged cookies
    createCookie(STAY_LOGGED_COOKIE_NAME,"yes");
    createCookie(TOKEN_COOKIE_NAME,readCookie(TOKEN_COOKIE_NAME));
  }
  
}

function onResume(){
  //reload the page to be sure that, if the token cookie expired, the user is asked to log in
  window.location.reload();
}


function logout(){
  //remove the token from the server
  eraseCookie(TOKEN_COOKIE_NAME);
  
  //post the information to the server and wait for the result
  var postData = { 
  token:token
  };
  
  
  //to be changed after the ws is done
  sendAjax( 'POST',
           LOGOUT_WS,
           postData,
           success,
           onError
           );
  
  return false;
  
}

function success(data){
  var dataObject = parseJSON(data);
  
  if(dataObject!=null) {
    var success = dataObject.success;
    var errorArray = dataObject.messages;
    
    //if we have an error, display the messages and logout
    if(errorArray){
      var errorArrayAsString="Login validation unsuccessful:";
      for(var i=0;i<errorArray.length;i++){
        errorArrayAsString += "\n" + errorArray[i];
      }
      alert("Error: " + errorArrayAsString);
      return;
    }
    //alert(result + ", " + token);
    
    //check if the access was authorized
    if(success){
      //remove the token cookie
      eraseCookie(TOKEN_COOKIE_NAME);
      //redirect to the choose food page
      loadPage(LOGIN_PAGE);
    }
    
  } else {
    alert("error connecting to the server");
  }
}


$("#logout").click(logout);