/*load all the useful variables from database*/

var finalCallBack,foodTagArray,customFoodTagArray,foodColorArray,mealArray,favoriteFoodTagArray,suggestedFoodTagArray;
var foodTagLogArray,currentPlanArray,journalArray;

var activityTypeArray, activityIntensityArray, activityArray, favoriteActivityArray ;

/*starting the chain of functions loading the database objects*/
function startLoadingDataFromDatabase(callback){
  finalCallBack = callback;
  loadFoodColors();
}

/*take the results of a database query and saves it into an array*/
function saveResults(results,array,callback) {
  if (results.rows && results.rows.length) {
    for (i = 0; i < results.rows.length; i++){
      array.push(results.rows.item(i));
    }
  }
  callback();
}

function loadFoodColors(){
  foodColorArray=[];
  getAllFoodColors(
    function (results) {
      saveResults(results,foodColorArray,loadFoodTags);
    }
  );
}

function loadFoodTags(){
  foodTagArray = [];
  getAllFoodTags(
    function (results) {
      saveResults(results,foodTagArray,loadMeals);
    }
  );
}


function loadMeals(){
  mealArray=[];
  getAllMeals(
    function (results) {
      saveResults(results,mealArray,loadFavoriteFoodTags);
    }
  );
}

function loadFavoriteFoodTags(){
  favoriteFoodTagArray=[];
  getAllFavoriteFoodTags(
    function (results) {
      saveResults(results,favoriteFoodTagArray,loadSuggestedFoodTags);
    }
  );

}

function loadSuggestedFoodTags(){
  suggestedFoodTagArray=[];
  getAllSuggestedFoodTags(
    function (results) {
      saveResults(results,suggestedFoodTagArray,loadCustomFoodTags);
    }
  );
}

function loadCustomFoodTags(){
  customFoodTagArray = [];
  getAllCustomFoodTags(
    function(results){
      saveResults(results, customFoodTagArray, loadFoodTagLogs);
    }
  );
}

function loadFoodTagLogs(){
  foodTagLogArray=[];
  getAllFoodTagLogs(
    function (results) {
      saveResults(results,foodTagLogArray,loadActivityTypes);
    }
  );
}

function loadActivityTypes(){
  activityTypeArray=[];
  getAllActivityTypes(
    function (results) {
      saveResults(results,activityTypeArray,loadActivityIntensities);
    }
  );
}

function loadActivityIntensities(){
  activityIntensityArray=[];
  getAllActivityIntensities(
                    function (results) {
                    saveResults(results,activityIntensityArray,loadActivities);
                    }
                    );
}

function loadActivities(){
  activityArray=[];
  getAllActivities(
                   function (results) {
                   saveResults(results,activityArray,loadFavoriteActivities);
                   }
                   );
}

function loadFavoriteActivities(){
  favoriteActivityArray=[];
  getAllFavoriteActivities(
                   function (results) {
                   saveResults(results,favoriteActivityArray,loadJournals);
                   }
                   );
}

function loadJournals(){
  journalArray = [];
  getAllJournals(
    function(results){
      saveResults(results, journalArray, finalCallBack);
    }
  );
}
