var CREATE_DB_QUERY = 
[ 
 "DROP TABLE IF EXISTS FoodTag; " ,
 "CREATE TABLE FoodTag (" 
 +  " foodTagId INTEGER PRIMARY KEY," 
 +  " name VARCHAR(150),"
 + 	" short VARCHAR(50),"
 +	" avgCals NUMERIC(10, 2),"
 + 	" avgProtein NUMERIC(10, 2),"
 +	" avgCarbs NUMERIC(10, 2),"
 +  " avgFat NUMERIC(10, 2),"
 +	" avgFiber NUMERIC(10, 2),"
 +	" forUserId INTEGER,"
 +	" colorId INTEGER);" , 

"DROP TABLE IF EXISTS FoodColor; " ,
 "CREATE TABLE FoodColor (" 
 +  " foodColorId INTEGER ," 
 +  " name VARCHAR(255));", 
  
 "DROP TABLE IF EXISTS Meal; " ,
 "CREATE TABLE Meal (" 
 +  " mealId INTEGER ," 
 +  " name VARCHAR(255));", 
 
 "DROP TABLE IF EXISTS FoodTagLog; " ,
 "CREATE TABLE FoodTagLog (" 
 +  " mealId INTEGER ," 
 +  " foodTagId INTEGER ,"
 +  " dateConsumed DATE ," 
 +  " servings INTEGER );" , 
 
 "DROP TABLE IF EXISTS FavoriteFoodTag; " ,
  "CREATE TABLE FavoriteFoodTag (" 
 +  " foodTagId INTEGER );", 

 "DROP TABLE IF EXISTS SuggestedFoodTag; " ,
 "CREATE TABLE SuggestedFoodTag (" 
 +  " mealId INTEGER ," 
 +  " foodTagId INTEGER,"
 +  " servings INTEGER);" , 

 "DROP TABLE IF EXISTS ActivityType; " ,
  "CREATE TABLE ActivityType (" 
 +  " activityTypeId INTEGER ," 
 +  " name TEXT );" , 

 "DROP TABLE IF EXISTS ActivityIntensity; " ,
 "CREATE TABLE ActivityIntensity (" 
 +  " activityIntensityId INTEGER," 
 +  " name TEXT );" , 

 "DROP TABLE IF EXISTS Activity;" ,
 "CREATE TABLE Activity (" 
 +  " activityId INTEGER," 
 +  " activityTypeId INTEGER," 
 +  " activityIntensityId INTEGER," 
 +  " name VARCHAR(200)," 
 +  " duration INTEGER," 
 +  " durationUnit VARCHAR(25)," 
 +  " dateTime DATETIME," 
 +  " notes TEXT,"
 +  " isFavorite BOOLEAN);",

"DROP TABLE IF EXISTS Journal;",
"CREATE TABLE Journal ("
+ " journalId INTEGER PRIMARY KEY,"
+ " isPrivate BOOLEAN,"
+ " title VARCHAR(250),"
+ " mood VARCHAR(25),"
+ " notes TEXT,"
+ " dateTime DATETIME);"
];

/* FOOD TAG VARIABLES */

var CUSTOM_FOOD_TAG_INSERT_QUERY = 
"INSERT INTO FoodTag (" 
+  " foodTagId," 
+  " name," 
+  " short," 
+  " avgCals," 
+  " avgProtein," 
+  " avgCarbs," 
+  " avgFat," 
+  " avgFiber," 
+  " forUserId," 
+  " colorId) VALUES (?,?,?,?,?,?,?,?,?,?);" ;

var CUSTOM_FOOD_TAG_UPDATE_QUERY =
"UPDATE FoodTag SET " 
+  " name = ?," 
+  " short = ?," 
+  " avgCals = ?," 
+  " avgProtein = ?," 
+  " avgCarbs = ?," 
+  " avgFat = ?," 
+  " avgFiber = ?," 
+  " colorId = ?"
+  " WHERE foodTagId = ? AND forUserId = ?;" ;

var CUSTOM_FOOD_TAG_DELETE_ALL_QUERY   = "DELETE FROM FoodTag WHERE forUserId <> 0";
var CUSTOM_FOOD_TAG_DELETE_QUERY       = "DELETE FROM FoodTag WHERE foodTagId = ? AND forUserId <> 0";
var CUSTOM_FOOD_TAG_SELECT_ALL_QUERY   = "SELECT * FROM FoodTag WHERE forUserId <> 0";
var CUSTOM_FOOD_TAG_SELECT_QUERY       = "SELECT * FROM FoodTag WHERE foodId = ? AND forUserId <> 0";


/* MEAL VARIABLES */
var MEAL_INSERT_QUERY       = "INSERT INTO Meal (mealId, name) VALUES (?,?)" 
var MEAL_UPDATE_QUERY       = "UPDATE Meal SET mealId=?, name=? WHERE mealId=?" 
var MEAL_DELETE_ALL_QUERY   = "DELETE FROM Meal";
var MEAL_DELETE_QUERY       = "DELETE FROM Meal WHERE mealId = ?";
var MEAL_SELECT_ALL_QUERY   = "SELECT * FROM Meal";
var MEAL_SELECT_QUERY       = "SELECT * FROM Meal WHERE mealId = ?";

/* FOOD COLOR VARIABLES */
var FOOD_COLOR_INSERT_QUERY       = "INSERT INTO FoodColor (foodColorId, name) VALUES (?,?)" 
var FOOD_COLOR_UPDATE_QUERY       = "UPDATE FoodColor SET name=? WHERE foodColorId=?" 
var FOOD_COLOR_DELETE_ALL_QUERY   = "DELETE FROM FoodColor";
var FOOD_COLOR_DELETE_QUERY       = "DELETE FROM FoodColor WHERE foodColorId = ?";
var FOOD_COLOR_SELECT_ALL_QUERY   = "SELECT * FROM FoodColor";
var FOOD_COLOR_SELECT_QUERY       = "SELECT * FROM FoodColor WHERE foodColorId = ?";

/* FOOD TAG VARIABLES */
var FOOD_TAG_INSERT_QUERY       = 
"INSERT INTO FoodTag VALUES "
+ " (?,?,?,?,?,?,?,?,?,?)" 
var FOOD_TAG_UPDATE_QUERY       = 
"UPDATE FoodTag SET " 
+ " name = ?,"
+ " short = ?,"
+ " avgCals = ?,"
+ " avgprotein = ?,"
+ " avgCarbs = ?,"
+ " avgFat = ?,"
+ " avgFiber = ?,"
+ " forUserId = ?,"
+ " colorId = ?,"
+ " WHERE foodTagId = ?"; 
var FOOD_TAG_DELETE_ALL_QUERY   = "DELETE FROM FoodTag;";
var FOOD_TAG_DELETE_QUERY       = "DELETE FROM FoodTag WHERE foodTagId = ?;";
var FOOD_TAG_SELECT_ALL_QUERY   = "SELECT * FROM FoodTag;";
var FOOD_TAG_SELECT_QUERY       = "SELECT * FROM FoodTag WHERE foodTagId = ?;";

/* FAVORITE FOOD TAG VARIABLES */
var FAVORITE_FOOD_TAG_INSERT_QUERY      = "INSERT INTO FavoriteFoodTag VALUES (?)";
var FAVORITE_FOOD_TAG_DELETE_ALL_QUERY  = "DELETE FROM FavoriteFoodTag";
var FAVORITE_FOOD_TAG_DELETE_QUERY     	= "DELETE FROM FavoriteFoodTag WHERE foodTagId = ?";
var FAVORITE_FOOD_TAG_SELECT_ALL_QUERY  = "SELECT * FROM FavoriteFoodTag;";
var FAVORITE_FOOD_TAG_SELECT_QUERY     	= "SELECT * FROM FavoriteFoodTag WHERE foodTagId = ?";

/* SUGGESTED FOOD TAG VARIABLES */
var SUGGESTED_FOOD_TAG_INSERT_QUERY       	= "INSERT INTO SuggestedFoodTag (mealId, foodTagId, servings) VALUES (?,?,?)";
var SUGGESTED_FOOD_TAG_DELETE_ALL_QUERY   	= "DELETE FROM SuggestedFoodTag";
var SUGGESTED_FOOD_TAG_SELECT_ALL_QUERY   	= "SELECT * FROM SuggestedFoodTag";
var SUGGESTED_FOOD_TAG_SELECT_BY_MEAL_QUERY = "SELECT * FROM SuggestedFoodTag WHERE mealId = ?;";

/* FOOD TAG LOG VARIABLES */
var FOOD_TAG_LOG_INSERT_QUERY       = "INSERT INTO FoodTagLog (mealId,foodTagId,dateConsumed,servings) VALUES (?,?,?,?);";
var FOOD_TAG_LOG_DELETE_ALL_QUERY   = "DELETE FROM FoodTagLog";
var FOOD_TAG_LOG_SELECT_ALL_QUERY   = "SELECT * FROM FoodTagLog";
var FOOD_TAG_LOG_UPDATE_QUERY       = "UPDATE FoodTagLog SET servings=? WHERE mealId = ? AND foodTagId = ? AND dateConsumed = ?;";

/* ACTIVITY TYPE VARIABLES */
var ACTIVITY_TYPE_INSERT_QUERY       = "INSERT   INTO ActivityType (activityTypeId, name) VALUES (?,?)";
var ACTIVITY_TYPE_DELETE_ALL_QUERY   = "DELETE   FROM ActivityType";
var ACTIVITY_TYPE_SELECT_ALL_QUERY   = "SELECT * FROM ActivityType";

/* ACTIVITY INTENSITY VARIABLES */
var ACTIVITY_INTENSITY_INSERT_QUERY       = "INSERT   INTO ActivityIntensity (activityIntensityId, name) VALUES (?,?)";
var ACTIVITY_INTENSITY_DELETE_ALL_QUERY   = "DELETE   FROM ActivityIntensity";
var ACTIVITY_INTENSITY_SELECT_ALL_QUERY   = "SELECT * FROM ActivityIntensity";

/* ACTIVITY VARIABLES */
var ACTIVITY_INSERT_QUERY       = "INSERT INTO Activity (activityId, activityTypeId, activityIntensityId, name, \
duration, durationUnit, dateTime, notes, isFavorite) VALUES (?,?,?,?,?,?,?,?,?)";
var ACTIVITY_DELETE_ALL_QUERY   = "DELETE FROM Activity";
var ACTIVITY_SELECT_ALL_QUERY   = "SELECT * FROM Activity";
var ACTIVITY_UPDATE_QUERY 		= "UPDATE Activity SET activityTypeId = ?, activityIntensityId = ?, name = ?, duration = ?, durationUnit = ?, dateTime = ?, notes = ?, isFavorite = ? WHERE activityId = ?;";

/* FAVORITE ACTIVITY VARIABLES */
var FAVORITE_ACTIVITY_INSERT_QUERY       = "INSERT INTO Activity (activityId, activityTypeId, activityIntensityId, name, \
duration, durationUnit, dateTime, notes, isFavorite) VALUES (?,?,?,?,?,?,?,?,?)";
var FAVORITE_ACTIVITY_DELETE_ALL_QUERY   = "DELETE   FROM Activity WHERE isFavorite = 1";
var FAVORITE_ACTIVITY_SELECT_ALL_QUERY   = "SELECT * FROM Activity WHERE isFavorite = 1";
/* PLAN VARIABLES */
var PLAN_INSERT_QUERY 			= "INSERT INTO Plan (planId, name, activityText, dateStarted) VALUES (?,?,?,?);";
var PLAN_DELETE_ALL_QUERY		= "DELETE FROM Plan;";
var PLAN_SELECT_QUERY			= "SELECT * FROM Plan ORDER BY planId DESC LIMIT 1;";

/* JOURNALS */
var JOURNAL_DELETE_ALL_QUERY 	= "DELETE FROM Journal;";
var JOURNAL_INSERT_QUERY		= "INSERT INTO Journal (journalId, isPrivate, title, mood, \
notes, dateTime) VALUES (?,?,?,?,?,?);";
var JOURNAL_UPDATE_QUERY		= "UPDATE Journal SET isPrivate = ?, title = ?, mood = ?, notes = ?, dateTime = ? WHERE journalId = ?;";
var JOURNAL_SELECT_ALL_QUERY 	= "SELECT * FROM Journal;";

/* Variable */
var VARIABLE_DELETE_ALL_QUERY 	= "DELETE FROM Variable;";
var VARIABLE_INSERT_QUERY 		= "INSERT INTO Variable (name, value) VALUES (?,?);";
var VARIABLE_UPDATE_QUERY		= "UPDATE Variable SET value = ? WHERE name = ?;";
var VARIABLE_SELECT_ALL_QUERY	= "SELECT * FROM Variable;";
var VARIABLE_DELETE_QUERY 		= "DELETE FROM Variable WHERE name = ?;";
var VARIABLE_SELECT_QUERY		= "SELECT * FROM Variable WHERE name = ?;";