var favoriteFoodArray, currentFoodTagId;

function onReadyFoodAdd() { startLoadingDataFromDatabase(updateFoodAddPage); }

/* Update the choose food page details*/
function updateFoodAddPage(){

  log("updateFoodChoosePage");
  updateMealSelect($("section#food_add #meal_select"));

  //retrieve the favorite food
  //var string = window.localStorage.getItem(FAVORITE_FOOD);
  //favoriteFoodArray = parseJSON(string);

  var currentMealId = readCookie(CURRENT_MEAL_COOKIE);
  currentFoodTagId = readCookie(CURRENT_FOOD_TAG_COOKIE);

  if(currentMealId){
    $("section#food_add select#meal_select").val(currentMealId);
  }

  //display the selected meal
  $("section#food_add #meal_select").val(currentMealId);//.selectmenu("refresh");
  var currentFood = getFoodTag(currentFoodTagId);

  if(currentFood) {
    populateFavoriteFoodAddIcon(currentFoodTagId);
    populateFoodAddDetails(currentFood);
  } else {
    //load information about the food
    var postData = {
      token: token
    };
    sendAjax(
             'POST',
             FOOD_WS + currentFoodTagId,
             postData,
             updateFoodTrackSuccess,
             onError
    );
  }
}

/* Set the favorite star */
function populateFavoriteFoodAddIcon(currentFoodTagId){
  if(isFavoriteFood(currentFoodTagId)){
    $('.favorite').attr('id', 'favorite-on');
  } else {
    $('.favorite').attr('id', 'favorite-off');
  }
}

/* Make a food favorite or not*/
function setFavoriteAddFood(tag){
  log("setFavoriteFood(" + tag + ")");
  var wsLink;

  if(tag){
    wsLink = FAVORITE_FOOD_TAG_ADD_WS;
  } else {
    wsLink = FAVORITE_FOOD_TAG_REMOVE_WS;
  }

  var postData = {
    token: token,
    foodTagId: currentFoodTagId
  };

  log("setFavoriteFood(" + tag + "): {" + token + "," + currentFoodTagId + "}");

  sendAjax(
   'POST',
   wsLink ,
   postData,
   generalSuccessFunction,
   generalErrorFunction
   );
}

function populateFoodAddDetails(currentFood){
  var foodProperty = ["name","avgCals","avgProtein","avgCarbs","avgFat","avgFiber","forUserId","colorId"];

  for(var i=0;i<foodProperty.length;i++){
    $("section#food_add #" + foodProperty[i]).text(currentFood[foodProperty[i]]);
  }
  Lungo.Router.section("food_add");
}


/*called when favorite icon is clicked*/
function favoriteAddClick(){
  if($('section#food_add .favorite').attr('id') == 'favorite-on') {
    $('section#food_add .favorite').attr('id','favorite-off');
    setFavoriteAddFood(false);
  } else {
    $('section#food_add .favorite').attr('id','favorite-on');
    setFavoriteAddFood(true);
  }
}


function updateFoodTrackSuccess(data){
  log("updateFoodTrackSuccess");
  var dataObject = parseJSON(data);
  log("data = \n---\n" + JSON.stringify(dataObject) +"\n---");

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var currentFood = dataObject;
    populateFoodDetails(currentFood);
  }
}


/*add a food for a meal on the server*/
function logFood(){
  $("section#food_add #log_food_button").val('Updating, please wait...'); //.button('refresh');
  var currentMealId = $("section#food_add #meal_select").val();
  var servings =  $("section#food_add #servings").attr('value');
  var postData = {
      token: token,
      date: currentDate(),
      newMealTypeId: currentMealId,
      foodTagId: currentFoodTagId,
      serving:servings
  };

  log("logFood: {" + token + "," + currentDate() + "," + currentMealId + "," + currentFoodTagId + "," + servings+ "}");
  sendAjax(
           'POST',
           LOG_FOOD_TAG_WS ,
           postData,
           logFoodSuccessFunction,
           logFoodErrorFunction
           );
}


/* Edit a custom food*/
function customFoodEdit(){
  loadPage(FOOD_CUSTOM_EDIT_PAGE);
}


/* Called when a food was added*/
function logFoodSuccessFunction(data){
  log("logFoodSuccessFunction");
  //log("data = \n---\n" + data +"\n---");
  loadPage(FOOD_PAGE);

}


function logFoodErrorFunction(xhr, ajaxOptions, thrownError){
  $("section#food_add #log_food_button").val('Track Food').button('refresh');
  alert("Error: " + xhr.status + " - " + thrownError);
}
