function onReadyFoodChoose() { updateFoodChoosePage(); }

/* Update the choose food page details*/
function updateFoodChoosePage(){
  log("updateFoodChoosePage");

  //update the "My Food" section
  // var postData = {
  //   token: token,
  //   date: currentDate()
  // };

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"CustomFoodTag,FavoriteFoodTag"
  };

  sendAjax(
           'POST',
           DYNAMIC_DATA_WS,
           postData,
           updateFoodChoosePageSuccess,
           onError
           );

  //check if I need to load a different page
  var page = readCookie(CURRENT_SUBPAGE_COOKIE);
  if(page){
    eraseCookie(CURRENT_SUBPAGE_COOKIE);
    log("Load " + page + " page");
    chooseFoodDisplayTab(page);
  }

}

/* Called after response with My Food information is received */
function updateFoodChoosePageSuccess(data){
  log("updateFoodChoosePageSuccess");
  var meal_id = readCookie(CURRENT_MEAL_COOKIE);
  log("Meal ID: " + meal_id);
  var dataObject = parseJSON(data);

  log("data = \n---\n" + JSON.stringify(dataObject) +"\n---");

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  var errorMessage = errorToString(dataObject);

  if(errorMessage){
    var errorMessage = "Error:\n" + errorMessage;
    alert(errorMessage);
    return;
  }

  if(dataObject!=null) {
    // Favorite
    var array = dataObject.FavoriteFoodTag;
    if(array.length > 0){
      log("FavoriteFoodTag downloaded. Saving to database");
      deleteAllFavoriteFoodTags();
      for (var i = 0; i < array.length; i++) {
        insertFavoriteFoodTag(array[i]);
      }
    }

    // Suggested
    // array = dataObject.SuggestedFoodTag;
    // if(array.length > 0){
    //   log("SuggestedFoodTag downloaded. Saving to database");
    //   deleteAllSuggestedFoodTags();
    //   for (var i = 0; i < array.length; i++) {
    //     insertSuggestedFoodTag(array[i]);
    //   }
    // }

    // Custom
    array = dataObject.CustomFoodTag;
    if(array.length > 0){
      log("CustomFoodTag downloaded. Saving to database");
      deleteAllCustomFoodTags();
      for (var i = 0; i < array.length; i++) {
        insertCustomFoodTag(array[i]);
      }
    }

    // Start loading data
    log("Start loading data from local database");
    startLoadingDataFromDatabase(generateFoodChoosePage);

  }
}

/* Save the food id for future use*/
function saveFoodChoose(control) {
  log("saveFood: saving food id " + control.getAttribute("foodTagId"));
  createCookie(CURRENT_FOOD_TAG_COOKIE,control.getAttribute("foodTagId"));
  onReadyFoodAdd();
}

/* Save the food tag id for future use*/
function saveFoodChooseTag(control) {
  log("saveFoodTag: saving food tag id " + control.id);
  createCookie(CURRENT_FOOD_TAG_COOKIE,control.id);
  Lungo.Router.section("tag_food");
}

function chooseFoodDisplayTab(tabName){
  log("chooseFoodDisplayTab(" + tabName + ")");
  Lungo.Router.article("#choose_food", tabName)
}

function generateFoodChoosePage(){
  generateMyFoodList();
  generateCustomFoodList();
}

function generateMyFoodList(){
  log("Generate My Food List");
  var meal_id = readCookie(CURRENT_MEAL_COOKIE);
  $('#list-my-foods').html("");
  var foodDivElement = "<ul>";
  foodDivElement += "<li class='white-container'>Choose from a list of your favorites and suggested foods below.</li>";

  // Favorite section
  log("Generate favorite list");
  foodDivElement +=  "<li class='anchor'>My Favorites</li>";
  for (var i = 0; i < favoriteFoodTagArray.length; i++) {
    var crtFavoriteFood = getFoodTag(favoriteFoodTagArray[i].foodTagId);
    if(crtFavoriteFood){
      foodDivElement += createFoodLi(crtFavoriteFood);
    }
  }

  //Common food tag section
  log("Generate common food tag section");
  foodDivElement += "<li class='anchor'>Common Food</li>";
  for (var i = 0; i < foodTagArray.length; i++) {
    var crtFood = getFoodTag(foodTagArray[i].foodTagId);
    if(crtFood && crtFood.forUserId == 0){
      foodDivElement += createFoodLi(crtFood);
    }
  }
  foodDivElement += "</ul>";
  $('#list-foods').html(foodDivElement);

  Lungo.Notification.hide();
  Lungo.Events.init({
    'tap section#choose_food article#list-foods li.food': function() {saveFoodChoose(this);},
    'tap section#choose_food article#list-foods li.foodtag': function() {saveFoodChooseTag(this);}
  });
}

/* Generate the table for Custom Food*/
function generateCustomFoodList(){
  log("generateCustomFoodList");
  $('#list-custom').html("");

  var foodDivElement = "<ul>";
  foodDivElement += "<li class='white-container'><a id='add_custom_food' class='button big profile-btn'>+&nbsp;&nbsp; Add Custom Food</a></li>";
  foodDivElement += "<li class='anchor'>My Custom Foods</li>";

  for (var i = 0; i < customFoodTagArray.length; i++) {
    var crtFood = customFoodTagArray[i];
    foodDivElement += createFoodLi(crtFood);
  }

  $('#list-custom').html(foodDivElement);

  Lungo.Events.init({
    'tap section#choose_food #add_custom_food': function() { Lungo.Router.section("food_create"); },
    'tap section#choose_food article#list-custom li.food': function() {saveFoodChoose(this);}
  });

}




