/* Functionality associated with custom food tag functionality*/
// var foodTypeId;
var date = currentDate();

function onReadyFoodCreate() {
  $("section#food_create #food_add_form").validate();
  startLoadingDataFromDatabase(updateFoodCreateForm);
}

/* Select a food type from the list*/
function selectFoodType(crtFoodTypeId){
  log("food type selected = " + crtFoodTypeId);
  foodTypeId = crtFoodTypeId;
  $("section#food_create #food_type_span").text("-" + getFoodType(crtFoodTypeId).name);

  Lungo.Router.article("#food_create", "#food_create_content");
}

/* Called when favorite icon is clicked*/
function favoriteCreateClick(){
  if($('section#food_create .favorite').attr('id') == 'favorite-on') {
    $('section#food_create .favorite').attr('id','favorite-off');
  } else {
    $('section#food_create .favorite').attr('id','favorite-on');
  }
}

/* Update the types div*/
function updateFoodCreateForm(){
  updateMealSelect($("section#food_create #meal_select"));

  var currentMealId = readCookie(CURRENT_MEAL_COOKIE);

  if(currentMealId){
    $("section#food_create select#meal_select").val(currentMealId);
  }

  // var wrap = $('#food-type-list');

  // var foodDivElement = "<ul>";

  // for (var i = 0; i < foodTypeArray.length; i++) {
  //   var crtFoodType = foodTypeArray[i];
  //   if(crtFoodType){
  //     foodDivElement += "<li class='selectable'><div class='right'><span class='icon right'></span></div><a onclick='selectFoodType(" + crtFoodType.foodTypeId + ")'>" + crtFoodType.name + "</a></li>";
  //   }
  // }

  // foodDivElement += "</ul>";
  // wrap.html(foodDivElement);

  // log("add food tags");

  // var dropdownList = $("#foodGroup")[0];
  // //clear the current options if any
  // while(dropdownList.options.length > 0){
  //   dropdownList.remove(0);
  // }

  // var option = new Option("Pick one", "0");
  // dropdownList.add(option, null);

  // $.each(foodTagArray,
  //        function() {
  //        var option = new Option(this.name, this.foodTagId);
  //        dropdownList.add(option, null);
  //        }
  //        );


}

/* Add a a custom food*/
function addCustomFoodTag(){
  //$("#commentForm").validate().form();
  if(!$("section#food_create #food_add_form").validate().form()){
    alert("Missing values from the required fields");
    return;
  };

  //$("#add_food_button").val('Adding, please wait...').button('refresh');

  if($('#food_create .favorite').attr('id') == 'favorite-on') {
    isFavorite = YES;
  } else {
    isFavorite = NO;
  }

  var postData = {
    "token": token,
    "name": $("section#food_create #name").val(),
    "cals" : $("section#food_create #calories").val(),
    "protein" : $("section#food_create #protein").val(),
    "carbs" : $("section#food_create #carbs").val(),
    "fat" : $("section#food_create #fat").val(),
    "fiber" : $("section#food_create #fiber").val()
    // "isFavorite" : isFavorite
  };

  // var foodProperty = ["name","servingUnit","calories","caloriesFat","totalFat","saturatedFat","transFat",
  //                     "cholesterol","sodium","potassium","totalCarbs","dietaryFiber","protein","sugars"];
  // var logMessage = "";
  // for(var i=0;i<foodProperty.length;i++){
  //   postData[foodProperty[i]] =  $("#" + foodProperty[i]).val();
  //   logMessage+= "&" + foodProperty[i]+ "=" + $("#" + foodProperty[i]).val();
  // }

  // var servingSize = $("#serve_size_integer_select").val() + $("#serve_size_decimal_select").val();

  // postData["servingSize"] = servingSize;
  // postData["foodTagId"] = $("#foodGroup").val();

  // log("addCustomFood: {token=" + token
  //     + ",foodTypeId=" + foodTypeId
  //     + ",servingSize=" + servingSize
  //     + "&foodTagId=" + $("#foodGroup").val()
  //     + logMessage + "}");

sendAjax(
 'POST',
 CUSTOM_FOOD_TAG_ADD_WS,
 postData,
 addCustomFoodTagLog,
 foodAddErrorFunction
 );
}

function addCustomFoodTagLog(data){
  var dataObject = parseJSON(data);

  if($('#food_create .favorite').attr('id') == 'favorite-on') {
    isFavorite = YES;
  } else {
    isFavorite = NO;
  }

  var post = {
    "token"            : token,
    "foodTagId"        : dataObject.foodTagId,
    "newMealTypeId"    : $("section#food_create #meal_select").val(),
    "date"             : currentDate(),
    "serving"          : $("section#food_create #servings").val(),
    // "isFavorite"       : isFavorite
  };
  sendAjax(
   'POST',
   LOG_FOOD_TAG_WS ,
   post,
   addFoodSuccessFunction,
   foodAddErrorFunction
   );
}

/* Called when a food was added*/
function addFoodSuccessFunction(data){
  log("addFoodSuccessFunction");
  //log("data = \n---\n" + data +"\n---");
  //save in a cookie the page that needs to be loaded
  // createCookie(CURRENT_SUBPAGE_COOKIE, "#list-custom");
  Lungo.Router.back()
  //setTimeout(function() { loadPage(FOOD_CHOOSE_PAGE);},3000);

}

function foodAddErrorFunction(xhr, ajaxOptions, thrownError){
  log("Error: status=" + xhr.status + ", message = " + thrownError + ", message = " + xhr.responseText);
  alert("Error: status=" + xhr.status + ", message = " + thrownError + ", did you choose a food type?");
  //$("#add_food_button").val('Add Food').button('refresh');

}

/* Populate random values - for testing purposes */
function populateRandomValues(){
  var foodProperty = ["calories","caloriesFat","totalFat","saturatedFat","transFat",
  "cholesterol","sodium","potassium","totalCarbs","dietaryFiber","protein","sugars"];

  for(var i=0;i<foodProperty.length;i++){
    $("#" + foodProperty[i]).val(Math.floor((Math.random()*100)+1));

  }
}
