var currentFoodTagId;
var selectedDate;
var storedMealId;

function onReadyFoodEdit() {
  selectedDate = currentDate();
  storedMealId = readCookie(CURRENT_MEAL_TYPE_COOKIE);
  currentFoodTagId = readCookie(CURRENT_FOOD_TAG_COOKIE);
  startLoadingDataFromDatabase(updateFoodEditPage);
}

/* Update the choose food page details*/
function updateFoodEditPage(){

  log("updateFoodTrackPage");
  updateMealSelect($("section#food_update #meal_select"));

  // Retrieve the meal to food
  var currentFoodTag = getFoodTag(currentFoodTagId);
  log("Selected date: " + selectedDate);

  var currentFoodTagLog = getFoodTagLog(selectedDate, storedMealId, currentFoodTagId);
  log("Food tag log array length: " + foodTagLogArray.length);

  var currentMealId = readCookie(CURRENT_MEAL_TYPE_COOKIE);
  log("CurrentMeal = " + currentMealId + ", currentFoodTagId = " + currentFoodTagId);

  // Display the selected meal
  $("section#food_update #meal_select").val(currentMealId); //.selectmenu("refresh");
  if(currentFoodTagLog){
    $("section#food_update #servings").val(currentFoodTagLog.servings); //.slider("refresh");
  }

  if(currentFoodTag) {
    populateFavoriteFoodEditIcon(currentFoodTagId);
    populateFoodDetails(currentFoodTag);
  } else {
    alert("cannot find the food, need to load it from the server (To be implemented)");
  }
}

/* Set the favorite star */
function populateFavoriteFoodEditIcon(currentFoodTagId){
  if(isFavoriteFood(currentFoodTagId)){
    $('section#food_update .favorite').attr('id', 'favorite-on');
  } else {
    $('section#food_update .favorite').attr('id', 'favorite-off');
  }
}

function populateFoodDetails(currentFoodTag){
  var foodProperty = ["name","avgCals","avgProtein","avgCarbs","avgFat","avgFiber","forUserId","colorId"];

  for(var i=0;i<foodProperty.length;i++){
    $("section#food_update #" + foodProperty[i]).text(currentFoodTag[foodProperty[i]]);

  }
  Lungo.Router.section("food_update");
}

/* Make a food favorite or not*/
function setFavoriteEditFood(tag){
  log("setFavoriteFood(" + tag + ")");
  var wsLink;

  if(tag){
    wsLink = FAVORITE_FOOD_TAG_ADD_WS;
  } else {
    wsLink = FAVORITE_FOOD_TAG_REMOVE_WS;
  }

  var postData = {
    token: token,
    foodTagId: currentFoodTagId
  };

  log("setFavoriteFood(" + tag + "): {" + token + "," + currentFoodTagId + "}");

  sendAjax(
   'POST',
   wsLink ,
   postData,
   generalSuccessFunction,
   generalErrorFunction
   );
}

/* Called when favorite icon is clicked*/
function favoriteEditClick(){
  if($('section#food_update .favorite').attr('id') == 'favorite-on') {
    $('section#food_update .favorite').attr('id','favorite-off');
    setFavoriteEditFood(false);
  } else {
    $('section#food_update .favorite').attr('id','favorite-on');
    setFavoriteEditFood(true);
  }
}



/* Add a food for a meal on the server */
function logFoodEditUpdate(){
  log("Update food tag log.");
  //$("#log_food_update_button").val('Updating, please wait...').button('refresh');

  var selectedMealId = $("section#food_update #meal_select").val();
  var servings =  $("section#food_update #servings").attr('value');
  var postData = {token: token,
                    dateConsumed: selectedDate,
                    foodTagId: currentFoodTagId,
                    oldMealId: storedMealId,
                    newMealId: selectedMealId,
                    servings: servings
                  };
  sendAjax(
           'POST',
           LOG_FOOD_TAG_EDIT_WS,
           postData,
           logFoodEditUpdateSuccessFunction,
           logFoodEditErrorFunction
           );
}

/* Called when an answer is received from the server*/
function logFoodEditUpdateSuccessFunction(data){
  log("logFoodUpdateSuccessFunction");
  loadPage(FOOD_PAGE);
}

/* Edit a food for a meal*/
function logFoodDelete(){
    var postData = {
          token: token,
          date: selectedDate,
          foodTagId: currentFoodTagId,
          mealTypeId: storedMealId
    };

    sendAjax(
             'POST',
             LOG_FOOD_TAG_REMOVE_WS,
             postData,
             logFoodEditDeleteSuccessFunction,
             logFoodEditErrorFunction
             );

}

/* Called when an answer is received from the server*/
function logFoodEditDeleteSuccessFunction(data){
  log("logFoodSuccessFunction");
  loadPage(FOOD_PAGE);
}

/* Called when an error is received from the server*/
function logFoodEditErrorFunction(xhr, ajaxOptions, thrownError){
  $("section#food_update #log_food_update_button").val('Update').button('refresh');
  alert("Error: " + xhr.status + " - " + thrownError);
}