/* utils for the daily food screen */

/*  CONSTANTS  */

//food types
//var GOLD=1, SILVER=2, GREEN=3,BLUE=4;

/* Web services */
//var DYNAMIC_DATA_WS           = SERVER_WS + "dynamicdata/";
//var FLUID_INC_WS              = SERVER_WS + "diet/fluidinc/";
var FLUID_WS                  = SERVER_WS + "diet/fluid/";
//var FLUID_DEC_WS              = SERVER_WS + "diet/fluiddec/";
var CUSTOM_FOOD_WS            = SERVER_WS + "diet/customfood/";
var FOOD_WS                   = SERVER_WS + "diet/food/";

var SEARCH_FOOD_WS            = SERVER_WS + "diet/searchfood/";
var SUGGESTED_AND_FOOD_INTAKE_WS = SERVER_WS + "diet/get_suggested_consumed_food_tag";

var LOG_FOOD_TAG_WS           = SERVER_WS + "diet/logfoodtag/";
var LOG_FOOD_TAG_EDIT_WS      = SERVER_WS + "diet/editdeletefoodtaglog/";
var LOG_FOOD_TAG_REMOVE_WS    = SERVER_WS + "diet/removefoodtaglog/";

var FAVORITE_FOOD_TAG_ADD_WS      = SERVER_WS + "diet/addfavoritefoodtag/";
var FAVORITE_FOOD_TAG_REMOVE_WS   = SERVER_WS + "diet/removefavoritefoodtag/";

var CUSTOM_FOOD_TAG_ADD_WS        = SERVER_WS + "diet/addcustomfoodtag/";
var CUSTOM_FOOD_TAG_EDIT_WS       = SERVER_WS + "diet/customfoodedit/";
var CUSTOM_FOOD_TAG_REMOVE_WS     = SERVER_WS + "diet/removecustomfoodtag/";


//cups for the fluids
var CUP_BLUE = "../img/icons-cup-blue.png";
var CUP_GREY = "../img/icons-cup-grey.png";

//no of fluid cups
var FLUID_NO = 8;

//cookies
var CURRENT_MEAL_COOKIE         = "current_meal_cookie";
var CURRENT_FOOD_COOKIE         = "current_food_cookie";
var CURRENT_MEAL_TO_FOOD_COOKIE = "current_meal_to_food_cookie";
var CURRENT_SUBPAGE_COOKIE      = "current_subpage_cookie";
var CURRENT_FOOD_TAG_COOKIE     = "current_food_tag_cookie";
var CURRENT_MEAL_TYPE_COOKIE    = "current_meal_type_cookie";

//keys for saving values locally
//static data keys for local storage
var FOOD              = "sanford_food";
var FOOD_LOCAL        = "sanford_food_local";//a part of FOOD used for local search
var MEAL              = "sanford_meal";
var FOOD_TYPE         = "sanford_food_type";
var FOOD_COLOR        = "sanford_food_color";
var FOOD_TAG          = "sanford_food_tag";
var FOOD_TO_FOOD_TAG  = "sanford_food_to_food_tag";

var MOST_USED_FOOD    = "sanford_most_used_food";
var FAVORITE_FOOD     = "sanford_favorite_food";
var MEAL_TO_FOOD      = "sanford_meal_to_food";
var CUSTOM_FOOD       = "sanford_custom_food";

//maximum number of FOODs displayed
var FOOD_MAX_NO = 150;
var SEARCH_BATCH_SIZE = 10;


//static variables for the food section

/*return the food having an food id (id)*/
function getFood(foodId){

  for(var i=0;i<foodArray.length;i++){
    if(foodArray[i].foodId == foodId){
      return foodArray[i];
    }
  }

  return null;
}

/*returns a meal from a meal array (meal) with a certain id (mealId)*/
function getMeal(mealId){
  for(var i=0;i<mealArray.length;i++){
    if(mealArray[i].mealId == mealId){
      return mealArray[i];
    }
  }
  return null;
}

/*returns the food tag with a certain id*/
function getFoodTag(foodTagId){
  for(var i=0;i<foodTagArray.length;i++){
    if(foodTagArray[i].foodTagId == foodTagId){
      return foodTagArray[i];
    }
  }
  return null;
}

/*find out if a food is favorite*/
function isFavoriteFood(foodTagId){
  for(var i=0;i<favoriteFoodTagArray.length;i++){
    if(favoriteFoodTagArray[i].foodTagId==foodTagId){
      return true;
    }
  }
  return false;
}

/*get the foot color as a string*/
function getFoodColorAsString(food){
  var foodColorId = food.colorId;
  for(var i=0;i<foodColorArray.length;i++){
    if(foodColorId == foodColorArray[i].foodColorId){
      return foodColorArray[i].name;
    }
  }
  return "";
}

function getColorName(colorId){
  for(var i=0;i<foodColorArray.length;i++){
    if(colorId == foodColorArray[i].foodColorId){
      return foodColorArray[i].name;
    }
  }
  return "";
}

/*returns a meal from a meal array (meal) with a certain id (mealId)*/
function getMealToFood(mealToFoodId){
  for(i=0;i<mealToFoodArray.length;i++){
    if(mealToFoodArray[i].mealToFoodId == mealToFoodId){
      return mealToFoodArray[i];
    }
  }
  return null;
}

function getFoodTagLog(date, mealId, foodTagId){
  for(i=0;i<foodTagLogArray.length;i++){
    if(foodTagLogArray[i].dateConsumed == date && foodTagLogArray[i].mealId == mealId && foodTagLogArray[i].foodTagId == foodTagId){
      return foodTagLogArray[i];
    }
  }
  return null;
}

/*returns a food type with a certain id (foodTypeId)*/
function getFoodType(foodTypeId){
  for(i=0;i<foodTypeArray.length;i++){
    if(foodTypeArray[i].foodTypeId == foodTypeId){
      return foodTypeArray[i];
    }
  }
  return null;
}

/*save the food id for future use*/
function saveFood(control, url) {
  log("saveFood: saving food id " + control.getAttribute("foodTagId"));
  createCookie(CURRENT_FOOD_TAG_COOKIE,control.getAttribute("foodTagId"));
  loadPage(url);
}

/*save the food tag id for future use*/
function saveFoodTag(control, url) {
  log("saveFoodTag: saving food tag id " + control.id);
  createCookie(CURRENT_FOOD_TAG_COOKIE,control.id);
  loadPage(url);
}



/*create one line in a table of foods*/
function createFoodLi(crtFood){
  var crtFoodColor = getFoodColorAsString(crtFood);

  /*var template = "<li class='selectable ?_label food' onClick='saveFood(this,FOOD_ADD_PAGE)' id='?'>\*/
  var template = "<li class='selectable ?_label food' foodTagId='?' draggable='false'>\
  <div class='right'><span class='icon right'></span></div>?</li>";

  var crtHtml = applyTemplate(template,[crtFoodColor,crtFood.foodTagId,crtFood.name]);

  return crtHtml;
}

/*create one line in a table of foods*/
function createSearchFoodLi(crtFood){
  var crtFoodColor = getFoodColorAsString(crtFood);

  var template = "<li class='selectable ?_label searchfood' id='?' draggable='false'>\
  <div class='right'><span class='icon right'></span></div>?</li>";

  var crtHtml = applyTemplate(template,[crtFoodColor,crtFood.foodId,crtFood.name]);

  return crtHtml;
}

/*create one line in a table of foods*/
function createCustomFoodLi(crtFood){
  var crtFoodColor = getFoodColorAsString(crtFood);

  /*var template = "<li class='selectable ?_label customfood' onClick='saveFood(this,FOOD_CUSTOM_SELECTED_PAGE)' id='?'>\*/

  var template = "<li class='selectable ?_label customfood' id='?' draggable='false'>\
  <div class='right'><span class='icon right'></span></div>?</li>";

  var crtHtml = applyTemplate(template,[crtFoodColor,crtFood.foodTagId,crtFood.name]);

  return crtHtml;
}


/*create one line in a table of food tags*/
function createFoodTagLi(crtFoodTag){

  /*var template = "<li class='selectable' onClick='saveFoodTag(this,FOOD_TAG_PAGE)' id='?'>\*/

  var template = "<li class='selectable foodtag' foodTagId='?' draggable='false'>\
  <div class='right'><span class='icon right'></span></div>?</li>";

  var crtHtml = applyTemplate(template,[crtFoodTag.foodTagId,crtFoodTag.name]);

  return crtHtml;
}


/*called when a food was added*/
function generalSuccessFunction(data){
  log("generalSuccessFunction");
  log("data = \n---\n" + JSON.stringify(data) +"\n---");
}

function generalErrorFunction(xhr, ajaxOptions, thrownError){
  log("generalErrorFunction");
  log("Error: \nStatus: " + xhr.status + " \nError: " + thrownError + "\nMessage: " + xhr.responseText);
  alert("Error: " + xhr.status + " - " + thrownError);
}

/*generate the drop down meal select*/
function updateMealSelect(control){
  var dropdownList = control[0];

  //clear the current options if any
  while(dropdownList.options.length > 0){
    dropdownList.remove(0);
  }

  $.each(mealArray,
     function() {
      var option = new Option(this.name, this.mealId);
      dropdownList.add(option, null);
     }
  );
}
