function onReadyJournal() {
  document.addEventListener("backbutton", onBackKeyDown, false);
  $("section#journal #current_date_span") .text(niceFormatDate(currentDate()));
  var crtDate = currentDate();

  if(crtDate==todayDate()){
    $("section#journal #tomorrow_button").hide();
  } else {
    Lungo.Events.init({
      'tap section#journal #tomorrow_button': tomorrow
    });
  }
  updatePageJournal();
}

/* Update the daily food page details */
function updatePageJournal(){
  log("updatePage - Journal");

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,Journal,ProfileData,Plan"
  };

  sendAjax(
           'POST',
           DYNAMIC_DATA_WS,
           postData,
           updatePageJournalSuccess,
           onError
           );
}

function updatePageJournalSuccess(data){
	var dataObject = parseJSON(data);

	if(dataObject!=null) {
	    setMenuTitle(dataObject.UserInfo);

      var array;

	    // User's plan
	    var plan = dataObject.Plan;
	    displayPlanInfo(plan);

	    array = dataObject.Journal;
	    if(array){
	      log("Journal downloaded. Saving to database");
	      deleteAllJournals();
	      for (var i = 0; i < array.length; i++) {
	        var crtJournal = array[i];
	        if(crtJournal.is_deleted !=YES){
	          insertJournal(array[i]);
	        }
	      }
	    }
	}
	log("Loading data from database");
	startLoadingDataFromDatabase(renderJournalPage);
}

function renderJournalPage(){
	log("Rendering Journal page");
	var wrap = $('section#journal #journal_list');
  var journalDivElement = $('<ul>');
  var selectedDate = new Date(currentDate());
  selectedDate.setHours(0,0,0,0);
  selectedDate.setDate(selectedDate.getDate() + 1);
  log("Journal array length: " + journalArray.length);

	for (var i = 0; i < journalArray.length; i++) {
    var crtItem = journalArray[i];
    var dateTime = crtItem.dateTime;
    var template = "<li class=\"selectable journal_entry\" id=\"?\"><div class=\"right\">at ?</div>?<small>?</small></li>";
    var crtJournalHtml = applyTemplate(template,
	                      [crtItem.journalId,dateToTimeString(dateTime),crtItem.title,crtItem.notes]);
    journalDivElement.append(crtJournalHtml);
	}

  wrap.html(journalDivElement);
  Lungo.Notification.hide();
  Lungo.Events.init({
    'tap  section#journal .journal_entry': function() {
      createCookie(CURRENT_JOURNAL_COOKIE,$(this).attr('id'));
      onReadyJournalEdit();
    }
  });
}

// NO NEEDO
// function loadEditJournalPage(control){
//   log("Edit journal item");
//   createCookie(CURRENT_JOURNAL_COOKIE,control.id);
//   loadPage(JOURNAL_EDIT_PAGE);
// }