/* login page functions */

function onLoginReady() {
  document.addEventListener("backbutton", onBackKeyDown, false);

  $("form#login_form").hide();
  var sec_token = readCookie(TOKEN_COOKIE_NAME);

  if(sec_token){
    loadPage(FOOD_PAGE_FROM_LOGIN);
  } else {
    $("form#login_form").show();
  }
  databaseTableCheck();
  checkNewStaticData(loadStaticDataIfNeeded);
}

function loadStaticDataIfNeeded(yesOrNo){
  updateStaticData(enableLoginButton);
}

function enableLoginButton(){
  // Lungo.Notification.hide();
  $("#login_span").text("");
  if (navigator.userAgent.match(/(iPod|iPhone|iPad)/)) {
    Lungo.Events.init({
      'tap #login_btn_id': loginButtonClick
    });
  }
  Lungo.Notification.hide();
}

function loginButtonClick(){
  var username = $("#userN").val();
  var password = $("#passW").val();

  if(username==""){
    alert("User name cannot be empty");
    Lungo.Notification.hide();
    return;
  }

  if(password==""){
    alert("Password cannot be empty");
    Lungo.Notification.hide();
    return;
  }
  var postData = {
    username: username,
    password: password
  };

  sendAjax(
   'POST',
   LOGIN_WS,
   postData,
   loginResultSuccess,
   onError
   );
  return false;
};

function loginResultSuccess(data){

  var dataObject = parseJSON(data);
  var errorMessage = errorToString(dataObject);

  if(errorMessage){
    var errorMessage="Login validation unsuccessful:\n" + errorMessage;
    $("#passW").val("");
    $("#passW").focus();
    alert(errorMessage);
    return;
  }

  if(dataObject!=null) {

    var token = dataObject.token;

    //check if the access was authorized
    if(token){
      //set the token into a cookie
      createCookie(TOKEN_COOKIE_NAME,token, 28);

      loadFoodPageFunction();

    }
  } else {
    alert("Error connecting to the server.");
  }
}

function loadFoodPageFunction(){
  $("#status_div").text("");

  loadPage(FOOD_PAGE_FROM_LOGIN);
}

var gaPlugin;
function onDeviceReady() { gaPlugin = window.plugins.gaPlugin; gaPlugin.init(successHandler, errorHandler, "UA-35520770-1", 10); }