
 // static data loading
 // Step 1: load the static data version
 // Step 2: compare the version with the version of the local data
 // Step 3: if the version is different, reload the static data
 // Step 4: store the newer data in database
 
 // StaticDataVersion {
 //    "Version":"1.0"
 // }
 
 // StaticData {
 //    "Food":{....},
 //    "Meal":{...},
 //    "FoodType":{...},
 //    "FoodColor":{...},
 //    "FoodTag":{...},
 //    "ActivityType":{}, 
 //    "ActivityIntensity":{}
 // } 
 

var staticDataVersion;

/* constants */
var STATIC_DATA_VERSION = "staticDataVersion";
var STATIC_DATA_VERSIONS_WS  = SERVER_WS + "staticdataversion/";
var STATIC_DATA_WS           = SERVER_WS + "staticdata/";


//the function called after the static data is updated
var returnFunction, checkVersionReturnFunction, updateDataReturnFunction;


function checkNewStaticData(retFunction){
  checkVersionReturnFunction = retFunction;
  
  staticDataVersion = window.localStorage.getItem(STATIC_DATA_VERSION);
  
  if(!staticDataVersion || (staticDataVersion=="null")){
    staticDataVersion = "-1";
  }
  
  sendAjax(
           'POST',
           STATIC_DATA_VERSIONS_WS,
           null,
           checkNewStaticDataStep2,
           onError
           );
  
}

/* read the static data version and update the newer ones */
function checkNewStaticDataStep2(data){
  var dataObject = parseJSON(data);
  var dataObjectAsJson = JSON.stringify(dataObject);
  
  var serverStaticDataVersion = dataObject.Version;
  
  if(!serverStaticDataVersion) serverStaticDataVersion = 0;
  
  window.localStorage.setItem(STATIC_DATA_VERSION, serverStaticDataVersion);
  
  if(serverStaticDataVersion==staticDataVersion){
    checkVersionReturnFunction(NO);
  } else {
    checkVersionReturnFunction(YES);
  }
  
}


/* read the static data version and update the newer ones */

function updateStaticData(retFunction){
  updateDataReturnFunction = retFunction;
  
  var postData = {};
  
  sendAjax(
           'POST',
           STATIC_DATA_WS,
           postData,
           updateStaticDataStep2,
           onError
           );
}

 // read the static data version and update the newer ones
 // The format of the data will be:
 
 // {
 // "Meal":{..},
 // "FoodType":{...},
 // "FoodColor":{...},
 // "FoodTag":{...},
 // "ActivityType":{...},
 // "ActivityIntensity":{...}
 // }
 

function updateStaticDataStep2(data){
  
  var dataObject = parseJSON(data);
  
  var array = dataObject.Meal;
  if(array){
    deleteAllMeals();
    for (var i = 0; i < array.length; i++) {
      insertMeal(array[i]);
    }
  }
  
  array = dataObject.FoodColor;
  if(array){
    deleteAllFoodColors();
    
    for (var i = 0; i < array.length; i++) {
      insertFoodColor(array[i]);
    }
  }
  
   array = dataObject.FoodTag;
   if(array){
     deleteAllFoodTags();
    
     for (var i = 0; i < array.length; i++) {
       insertFoodTag(array[i]);
     }
  }
  
  array = dataObject.ActivityType;
  if(array){
    deleteAllActivityTypes();
    
    for (var i = 0; i < array.length; i++) {
      insertActivityType(array[i]);
    }
  }
  
  array = dataObject.ActivityIntensity;
  if(array){
    deleteAllActivityIntensities();
    
    for (var i = 0; i < array.length; i++) {
      insertActivityIntensity(array[i]);
    }
  }
  
  updateDataReturnFunction();
  
}
