/*date utils*/

//date is store in a cookie called "currentDate" in the format yyyy-mm-dd
var CURRENT_DATE_COOKIE_NAME = "currentDate";


//returns the current date. either from cookie or today
function currentDate(){
  var result = readCookie(CURRENT_DATE_COOKIE_NAME);
  if(result===null){ //cookie is not present
    var date=new Date();
    result = formatDate(date);
  }
  return result;
}

function todayDate(){
  var date=new Date();
  return formatDate(date);
}

//change the current date to tomorrow
function tomorrow(){
  var currentDate = readCookie(CURRENT_DATE_COOKIE_NAME);
  var myDate;
  if(currentDate===null){ //cookie is not present
    myDate=new Date();
  } else {
    var part = currentDate.split(/[^0-9]/);
    myDate = new Date(part[0], part[1]-1, part[2]);
  }
  myDate.setDate(myDate.getDate() + 1);
  result = formatDate(myDate);
  createCookie(CURRENT_DATE_COOKIE_NAME, result);
  location.reload(true);
}

//change the current date to tomorrow
function yesterday(){
  var currentDate = readCookie(CURRENT_DATE_COOKIE_NAME);
  var myDate;
  if(currentDate===null){
    //cookie is not present
    myDate=new Date();
  } else {
    var part = currentDate.split(/[^0-9]/);
    myDate = new Date(part[0], part[1]-1, part[2]);
  }
  myDate.setDate(myDate.getDate() - 1);
  result = formatDate(myDate);
  createCookie(CURRENT_DATE_COOKIE_NAME, result);
  location.reload(true);
}

function eraseDateCookie(){
  eraseCookie(CURRENT_DATE_COOKIE_NAME);
}

/*change the current date to today*/
function today(){
  eraseCookie(CURRENT_DATE_COOKIE_NAME);
  location.reload(true);
}

//formats a date object into yyyy-mm-dd
function formatDate(date){
  var   result = date.getFullYear() + "-" ;
  if(date.getMonth()<9){
    result +="0";
  }
  result += (date.getMonth()+1);

  result += "-";
  if(date.getDate()<10){
    result +="0";
  }
  result += date.getDate();
  return result;
}

/*converts a date from format 2012-10-11 into Oct 11, 2012*/
function niceFormatDate(dateAsString){
  if(dateAsString==todayDate()){
    return "Today";
  }
  var part = dateAsString.split(/[^0-9]/);
  var date = new Date(part[0], part[1]-1, part[2]-1);
  var dNames = new Array("Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun");
  var mNames = new Array("Jan", "Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov", "Dec");
  return dNames[date.getDay()] + ", " + mNames[dateAsString.substring(5,7)-1] + " " + dateAsString.substring(8,10) +", " + dateAsString.substring(0,4);
}

//build a date from the text representation
function makeDate(dateAsString){
  return new Date(dateAsString.substring(0,4),dateAsString.substring(5,7),dateAsString.substring(8,10));
}

function dateToTimeString(date){
  var part = date.toString().split(/[^0-9]/);
  var parsed = new Date(part[0],part[1]-1,part[2],part[3],part[4],part[5]);
  var hour = parsed.getHours();
  var minute = parsed.getMinutes();
  var ampm = "am";
  var mins = minute;
  if(hour >= 12){
    if(hour > 12){
      hour = hour - 12;
      ampm = "pm";
    }
  }

  if(minute < 10){
    mins = "0" + minute;
  }
  return hour + ":" + mins + " " + ampm;
}

// Convert date time to nice format: 
function niceDateTime(datetime){
  var date = niceFormatDate(datetime);
  var time = dateToTimeString(datetime);
  return date + " at " + time;
}




