// --------------Global Graphs---------------- //
function clearGraphs(){
  $('.table_container').html('');
  $('.graph_container').html('');
}


// --------------Weight---------------- //
function updatePageFood(){
  log("updatePage Weight - Progress");
  clearGraphs();
  var postData = {
   token: token,
   date: currentDate(),
   dataname:"User,ProfileData,Plan,Device,Weights"
  };
  log("Weight - send ajax");
  sendAjax(
    'POST',
    DYNAMIC_DATA_WS,
    postData,
    updatePageSuccessFood,
    onError
  );
}


function updatePageSuccessFood(data){
  log("updatePageSuccessFood - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    eraseCookie(TOKEN_COOKIE_NAME);
    loadPage(LOGIN_PAGE);
    return;

  }
  if(dataObject!=null){
    setMenuTitle(dataObject.UserInfo);
    var array;

    // User's plan
    var plan = dataObject.Plan;
    displayPlanInfo(plan);

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("weight");
    if(dataObject.Values && dataObject.Dates){
     arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
     arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});
     renderWeightChart(arrayDate, arrayValue, "Weight", "lbs", "vitals_weight", plan["goal_weight"]);
     renderTable(arrayValue, "Weight", "lbs", "vitals_weight");
   }
 }
 startUpdatingPageFood();
}


function startUpdatingPageFood(){
  generateProgressPageFood();
  Lungo.Notification.hide();
}

function generateProgressPageFood(){
	setDeviceStatus();
}



// --------------BMI---------------- //
function updatePageBMI(){
  log("updatePage BMI - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,BMI"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessBMI,
   onError
   );
}

function updatePageSuccessBMI(data){
  log("updatePageSuccess - Progress");

  var dataObject = parseJSON(data)
   //check if the user is still logged in
   if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bmi");
    if(dataObject.Values && dataObject.Dates){
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});
      renderChart(arrayDate, arrayValue, "BMI", "", "vitals_bmi");
      renderTable(arrayValue, "BMI", "", "vitals_bmi");
    }
  }
  startUpdatingPageBMI();
}

function startUpdatingPageBMI(){
  generateProgressPageBMI();
  Lungo.Notification.hide();
}

function generateProgressPageBMI(){
  setDeviceStatus();
}



// --------------Bone---------------- //
function updatePageBone(){
  log("updatePage Bone - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Bone"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessBone,
   onError
   );
}

function updatePageSuccessBone(data){
  log("updatePageSuccess - Progress");

  var dataObject = parseJSON(data)
   //check if the user is still logged in
   if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bone");
    if(dataObject.Values && dataObject.Dates){
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});
      renderChart(arrayDate, arrayValue, "Bone Density", "", "vitals_bone");
      renderTable(arrayValue, "Bone Density", "", "vitals_bone");
    }
  }
  startUpdatingPageBone();
}

function startUpdatingPageBone(){
  generateProgressPageBone();
  Lungo.Notification.hide();
}

function generateProgressPageBone(){
  setDeviceStatus();
}



// --------------Muscle---------------- //
function updatePageMuscle(){
  log("updatePage Muscle - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Muscle"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessMuscle,
   onError
   );
}

function updatePageSuccessMuscle(data){
  log("updatePageSuccess - Progress");

  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("muscle");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Muscle %", "%", "vitals_muscle");
      renderTable(arrayValue, "Muscle %", "%", "vitals_muscle");
    }
  }
  startUpdatingPageMuscle();
}

function startUpdatingPageMuscle(){
  generateProgressPageMuscle();
  Lungo.Notification.hide();
}

function generateProgressPageMuscle(){
  setDeviceStatus();
}



// --------------Bodyfat---------------- //
function updatePageBodyfat(){
  log("updatePage Body Fat - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,BodyFat"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessBodyfat,
   onError
   );
}

function updatePageSuccessBodyfat(data){
  log("updatePageSuccess - Progress");

  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bodyfat");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Body Fat %", "%", "vitals_bodyfat");
      renderTable(arrayValue, "Body Fat %", "%", "vitals_bodyfat");
    }
  }
  startUpdatingPageBodyfat();
}

function startUpdatingPageBodyfat(){
  generateProgressPageBodyfat();
  Lungo.Notification.hide();
}

function generateProgressPageBodyfat(){
  setDeviceStatus();
}


// --------------Hydration---------------- //
function updatePageHydration(){
  log("updatePage Hydration - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Hydration"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessHydration,
   onError
   );
}

function updatePageSuccessHydration(data){
  log("updatePageSuccess  - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("hydration");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Hydration %", "%", "vitals_hydration");
      renderTable(arrayValue, "Hydration %", "%", "vitals_hydration");
    }
  }
  startUpdatingPageHydration();
}

function startUpdatingPageHydration(){
  generateProgressPageHydration();
  Lungo.Notification.hide();
}

function generateProgressPageHydration(){
  setDeviceStatus();
}


// --------------Waist---------------- //
function updatePageWaist(){
  log("updatePage Waist - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Waist"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessWaist,
   onError
   );
}

function updatePageSuccessWaist(data){
  log("updatePageSuccessWaist - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("waist");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Waist", "inches", "vitals_waist");
      renderTable(arrayValue, "Waist", "inches", "vitals_waist");
    }
  }
  startUpdatingPageWaist();
}

function startUpdatingPageWaist(){
  generateProgressPageWaist();
  Lungo.Notification.hide();
}

function generateProgressPageWaist(){
  setDeviceStatus();
}




// --------------Hip---------------- //
function updatePageHip(){
  log("updatePage Hip - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Hip"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessHip,
   onError
   );
}

function updatePageSuccessHip(data){
  log("updatePageSuccessHip - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("hip");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Hip", "inches", "vitals_hip");
      renderTable(arrayValue, "Hip", "inches", "vitals_hip");
    }
  }
  startUpdatingPageHip();
}

function startUpdatingPageHip(){
  generateProgressPageHip();
  Lungo.Notification.hide();
}

function generateProgressPageHip(){
  setDeviceStatus();
}


// --------------Chest---------------- //
function updatePageChest(){
  log("updatePage Chest - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Chest"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessChest,
   onError
   );
}

function updatePageSuccessChest(data){
  log("updatePageSuccessChest - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("chest");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Chest", "inches", "vitals_chest");
      renderTable(arrayValue, "Chest", "inches", "vitals_chest");
    }
  }
  startUpdatingPageChest();
}

function startUpdatingPageChest(){
  generateProgressPageChest();
  Lungo.Notification.hide();
}

function generateProgressPageChest(){
  setDeviceStatus();
}


// --------------Thigh---------------- //
function updatePageThigh(){
  log("updatePage Thigh - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Thigh"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessThigh,
   onError
   );
}

function updatePageSuccessThigh(data){
  log("updatePageSuccessThigh - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("thigh");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Thigh", "inches", "vitals_thigh");
      renderTable(arrayValue, "Thigh", "inches", "vitals_thigh");
    }
  }
  startUpdatingPageThigh();
}

function startUpdatingPageThigh(){
  generateProgressPageThigh();
  Lungo.Notification.hide();
}

function generateProgressPageThigh(){
  setDeviceStatus();
}


// --------------Bicep---------------- //
function updatePageBicep(){
  log("updatePage Bicep - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Bicep"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessBicep,
   onError
   );
}

function updatePageSuccessBicep(data){
  log("updatePageSuccessBicep - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bicep");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Bicep", "inches", "vitals_bicep");
      renderTable(arrayValue, "Bicep", "inches", "vitals_bicep");
    }
  }
  startUpdatingPageBicep();
}

function startUpdatingPageBicep(){
  generateProgressPageBicep();
  Lungo.Notification.hide();
}

function generateProgressPageBicep(){
  setDeviceStatus();
}



// --------------Neck---------------- //
function updatePageNeck(){
  log("updatePage Neck - Progress");
  clearGraphs();

  var postData = {
    token: token,
    date: currentDate(),
    dataname:"User,ProfileData,Plan,Device,Neck"
  };

  sendAjax(
   'POST',
   DYNAMIC_DATA_WS,
   postData,
   updatePageSuccessNeck,
   onError
   );
}

function updatePageSuccessNeck(data){
  log("updatePageSuccessNeck - Progress");
  var dataObject = parseJSON(data);

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("neck");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Neck", "inches", "vitals_neck");
      renderTable(arrayValue, "Neck", "inches", "vitals_neck");
    }
  }
  startUpdatingPageNeck();
}

function startUpdatingPageNeck(){
  generateProgressPageNeck();
  Lungo.Notification.hide();
}

function generateProgressPageNeck(){
  setDeviceStatus();
}


// --------------BP---------------- //
var arraySystolic, arrayDiastolic;


function updatePageBP(){
  log("updatePage BP - Progress");

   var postData = {
     token: token,
     date: currentDate(),
     dataname:"User,ProfileData,Plan,Device,BP"
   };

  sendAjax(
    'POST',
    DYNAMIC_DATA_WS,
    postData,
    updatePageSuccessBP,
    onError
  );
}

function updatePageSuccessBP(data){
  log("updatePageSuccessBP - Progress");

  var dataObject = parseJSON(data);

  //log("data = \n---\n" + JSON.stringify(dataObject) +"\n---");

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bp");
    if(dataObject.Diastolic && dataObject.Systolic && dataObject.Dates){
      // Create arrays from JS objects
      arraySystolic = $.map(dataObject.Systolic, function(k,v){return [k]});
      arrayDiastolic = $.map(dataObject.Diastolic, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderBPChart(arrayDate, arraySystolic, arrayDiastolic, 'blood_pressure');
      renderBPTable(arraySystolic, arrayDiastolic, 'blood_pressure');
    }
  }
  startUpdatingPageBP();
}

function startUpdatingPageBP(){
  generateProgressPageBP();
  Lungo.Notification.hide();
}

function generateProgressPageBP(){
  setDeviceStatus();
}

function renderBPChart(dates, systolic, diastolic, chart_type){
  chart_type = 'graph_container_'+chart_type;
  var chart = new Highcharts.Chart({
    chart: {
      renderTo: chart_type,
      plotBackgroundColor: 'transparent',
      backgroundColor: 'rgba(255, 255, 255, .45)',
      borderRadius: '0'
    },
    credits: {
      enabled: false
    },
    rangeSelector:{
      selected: 1
    },
    title: {
      text: '',
            x: -20 // center
          },
          credits: {
            enabled: false
          },
          legend: {
            backgroundColor: 'transparent',
            borderWidth: '0'
          },
          exporting: {
            buttons: {
              printButton: {
                enabled: false
              },
              exportButton: {
                enabled: false
              }
            }
          },
          xAxis:{
            categories: dates,
            tickmarkPlacement: 'on',
            labels: {
              enabled: false
            },
            title: {
              enabled: false
            }
          },
          yAxis:{
            title: {
              text: 'mmHg'
            }
          },
          tooltip: {
            formatter: function() {
              return ''+
              this.x +': '+ Highcharts.numberFormat(this.y, 0, ',') + " mmHg";
            },
            enabled: false
          },
          legend: {
            enabled: false
          },
          plotOptions: {
            series: {
              enableMouseTracking: false
            }
          },
          series: [{
            showInLegend: true,
            name: 'Diastolic',
            data: diastolic,
            tooltip: {
              valueDecimals: 1
            }
          },{
            showInLegend: true,
            name: 'Systolic',
            data: systolic,
            tooltip: {
              valueDecimals: 1
            }
          }]
        });
}

function renderBPTable(systolic, diastolic, chart_type){
  if(systolic && diastolic){
    var strHtml = "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">";
    strHtml += "<thead>";
    strHtml += "<tr><td>Date</td><td>Diastolic</td><td>Systolic</td></tr>";
    strHtml += "</thead>";
    strHtml += "<tbody>";
    for(var i = 0; i < systolic.length; i++){

      strHtml += "<tr>";
      strHtml += "<td>" + niceFormatDate(systolic[i][0]) + "</td>";
      strHtml += "<td>" + diastolic[i][1] + " mmHg</td>";
      strHtml += "<td>" + systolic[i][1] + " mmHg</td>";
      strHtml +=  "</tr>";
    }
    strHtml +="</tbody>";
    strHtml += "</table>";
    chart_type = "#table_container_"+chart_type;
    $(chart_type).html(strHtml);
  }
}


// --------------Activity---------------- //
function updatePageActivity(){
  log("updatePage Activity - Progress");
  clearGraphs()

  var postData = {
   token: token,
   date: currentDate(),
   dataname:"User,ProfileData,Plan,Device,Step"
 };

 sendAjax(
  'POST',
  DYNAMIC_DATA_WS,
  postData,
  updatePageSuccessActivity,
  onError
  );
}

function updatePageSuccessActivity(data){
  log("updatePageSuccessActivity - Progress");

  var dataObject = parseJSON(data);


  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("activity");
    if(dataObject.Values && dataObject.Dates){
      // Create arrays from JS objects
      arrayValue = $.map(dataObject.Values, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderChart(arrayDate, arrayValue, "Step Intensity", "steps", "vitals_activity");
      renderTable(arrayValue, "Step Intensity", "steps", "vitals_activity");
    }
  }
  startUpdatingPageActivity();
}

function startUpdatingPageActivity(){
  generateProgressPageActivity();
  Lungo.Notification.hide();
}

function generateProgressPageActivity(){
  setDeviceStatus();
}