var arraySystolic, arrayDiastolic;


function updatePageBP(){
	log("updatePage - Progress");

   var postData = {
     token: token,
     date: currentDate(),
     dataname:"ProfileData,Plan,Device,BP"
   };

  sendAjax(
    'POST',
    DYNAMIC_DATA_WS,
    postData,
    updatePageSuccessBP,
    onError
  );
}

function updatePageSuccessBP(data){
  log("updatePageSuccessBP - Progress");

  var dataObject = parseJSON(data);

  //log("data = \n---\n" + JSON.stringify(dataObject) +"\n---");

  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }

  if(dataObject!=null) {
    var array;

    // User's plan
    var plan = dataObject.Plan;
    displayPlanInfo(plan);

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);

    $("select#progress_type").val("bp");
    if(dataObject.Diastolic && dataObject.Systolic && dataObject.Dates){
      // Create arrays from JS objects
      arraySystolic = $.map(dataObject.Systolic, function(k,v){return [k]});
      arrayDiastolic = $.map(dataObject.Diastolic, function(k,v){return [k]});
      arrayDate = $.map(dataObject.Dates, function(k,v){return [k]});

      renderBPChart(arrayDate, arraySystolic, arrayDiastolic, 'blood_pressure');
      renderBPTable(arraySystolic, arrayDiastolic, 'blood_pressure');
    }
  }
  startUpdatingPageBP();
}

function startUpdatingPageBP(){
  generateProgressPageBP();
  Lungo.Notification.hide();
}

function generateProgressPageBP(){
	setDeviceStatus();
}

function renderBPChart(dates, systolic, diastolic, chart_type){
  chart_type = 'graph_container_'+chart_type;
  var chart = new Highcharts.Chart({
    chart: {
      renderTo: chart_type,
      plotBackgroundColor: 'transparent',
      backgroundColor: 'rgba(255, 255, 255, .45)',
      borderRadius: '0'
    },
    credits: {
      enabled: false
    },
    rangeSelector:{
      selected: 1
    },
    title: {
      text: '',
            x: -20 // center
          },
          credits: {
            enabled: false
          },
          legend: {
            backgroundColor: 'transparent',
            borderWidth: '0'
          },
          exporting: {
            buttons: {
              printButton: {
                enabled: false
              },
              exportButton: {
                enabled: false
              }
            }
          },
          xAxis:{
            categories: dates,
            tickmarkPlacement: 'on',
            labels: {
              enabled: false
            },
            title: {
              enabled: false
            }
          },
          yAxis:{
            title: {
              text: 'mmHg'
            }
          },
          tooltip: {
            formatter: function() {
              return ''+
              this.x +': '+ Highcharts.numberFormat(this.y, 0, ',') + " mmHg";
            },
            enabled: false
          },
          legend: {
            enabled: false
          },
          plotOptions: {
            series: {
              enableMouseTracking: false
            }
          },
          series: [{
            showInLegend: true,
            name: 'Diastolic',
            data: diastolic,
            tooltip: {
              valueDecimals: 1
            }
          },{
            showInLegend: true,
            name: 'Systolic',
            data: systolic,
            tooltip: {
              valueDecimals: 1
            }
          }]
        });
}

function renderBPTable(systolic, diastolic, chart_type){
  if(systolic && diastolic){
    var strHtml = "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">";
    strHtml += "<thead>";
    strHtml += "<tr><td>Date</td><td>Diastolic</td><td>Systolic</td></tr>";
    strHtml += "</thead>";
    strHtml += "<tbody>";
    for(var i = 0; i < systolic.length; i++){

      strHtml += "<tr>";
      strHtml += "<td>" + niceFormatDate(systolic[i][0]) + "</td>";
      strHtml += "<td>" + diastolic[i][1] + " mmHg</td>";
      strHtml += "<td>" + systolic[i][1] + " mmHg</td>";
      strHtml +=  "</tr>";
    }
    strHtml +="</tbody>";
    strHtml += "</table>";
    chart_type = "#table_container_"+chart_type;
    $(chart_type).html(strHtml);
  }
}