var arrayWaist, arrayHip, arrayChest, arrayThigh, arrayBicep, arrayNeck;
$(document).ready(onReady);

function onReady() {
  updatePage()
}

function updatePage(){
  log("updatePage - Progress");    
  
    var postData = { 
      token: token, 
      date: currentDate(),
      dataname:"ProfileData,Plan,Device,Measurements"
    };
    
    sendAjax(
         'POST',
         DYNAMIC_DATA_WS,
         postData,
         updatePageSuccess,
         onError
      );
}

function updatePageSuccess(data){
  log("updatePageSuccess - Progress");
  
  var dataObject = parseJSON(data);
  
  //log("data = \n---\n" + JSON.stringify(dataObject) +"\n---");
  
  //check if the user is still logged in
  if(isUserLoggedIn (dataObject) == NO){
    loadPage(LOGIN_PAGE);
    return;
  }
  
  if(dataObject!=null) {
    var array;

    // User's plan
    var plan = dataObject.Plan;
    displayPlanInfo(plan);

    // User devices
    arrayDevices = dataObject.Device;
    checkDeviceStatus(arrayDevices);
    
    $("select#progress_type").val("all");
    if(dataObject){
      // Create arrays from JS objects
      prepareArray(dataObject);
      // Render measurement charts
      renderMeasurementCharts(arrayWaist, arrayHip, arrayChest, arrayThigh, arrayBicep, arrayNeck);
    }
  }
  startUpdatingPage();
}

function startUpdatingPage(){
  generateProgressPage();
  Lungo.Notification.hide();
}

function generateProgressPage(){
  setDeviceStatus();
}

function prepareArray(object){
  arrayWaist = $.map(object.Waist, function(v,k){return [v]});
  arrayHip = $.map(object.Hip, function(v,k){return [v]});
  arrayChest = $.map(object.Chest, function(v,k){return [v]});
  arrayThigh = $.map(object.Thigh, function(v,k){return [v]});
  arrayBicep = $.map(object.Bicep, function(v,k){return [v]});
  arrayNeck = $.map(object.Neck, function(v,k){return [v]});
}

function renderMeasurementCharts(arrayWaist, arrayHip, arrayChest, arrayThigh, arrayBicep, arrayNeck){
  var chart;
    chart = new Highcharts.Chart({
    chart: {
      renderTo: 'graph_container',
      zoomType: 'x'
    },
    title: {
     text: 'Measurements',
    },
    // subtitle: {
    //     text: 'Source: Sanford Health'
    // },
    credits: {
      enabled: false
    },
    legend: {
      backgroundColor: '#fff'
    },
    exporting: {
      buttons: {
        printButton: {
          enabled: false
        },
        exportButton: {
          enabled: false
        }
      }
    },
    xAxis: {
      type: 'datetime',
      tickmarkPlacement: 'on',
      title: {
        enabled: false
      }
    },
    yAxis: {
      title: {
        text: "inches"
      },
      labels: {
        formatter: function() {
          return this.value;
        }
      }
    },
    tooltip: {
      formatter: function() {
        return ''+
        this.x +': '+ Highcharts.numberFormat(this.y, 0, ',') + " inches";
      }
    },
    series: [{
      name: "Waist",
      data: arrayWaist
    },{
      name: "Hip",
      data: arrayHip
    },{
      name: "Chest",
      data: arrayChest
    },{
      name: "Thigh",
      data: arrayThigh
    },{
      name: "Bicep",
      data: arrayBicep
    },{
      name: "Neck",
      data: arrayNeck
    }]
  }); 
}