var arrayDevices, arrayDate, arrayValue;
var bp_synced = false, scale_synced = false, tape_synced = false, pedometer_synched = false;

function loadProgressPage(){
	switch($("#progress_type").val()){
		case "weight":
			loadPage("vitals.html");
			break;
		case "bmi":
			loadPage("vitals_bmi.html");
			break;
		case "bodyfat":
			loadPage("vitals_bodyfat.html");
			break;
		case "muscle":
			loadPage("vitals_muscle.html");
			break;
		case "bone":
			loadPage("vitals_bone.html");
			break;
		case "hydration":
			loadPage("vitals_hydration.html");
			break;
		case "bp":
			loadPage("vitals_bp.html");
			break;
		case "activity":
			loadPage("vitals_activity.html");
			break;
		case "waist":
			loadPage("vitals_waist.html");
			break;
		case "hip":
			loadPage("vitals_hip.html");
			break;
		case "chest":
			loadPage("vitals_chest.html");
			break;
		case "thigh":
			loadPage("vitals_thigh.html");
			break;
		case "bicep":
			loadPage("vitals_bicep.html");
			break;
		case "neck":
			loadPage("vitals_neck.html");
			break;		
		default:
			loadPage("vitals_measurements.html");		
	}
}

function checkDeviceStatus(arrayDevice){
	if(arrayDevice){
      for(var i = 0; i < arrayDevice.length; i++){
        var crtDevice = arrayDevice[i];
        log(crtDevice.type.toLowerCase());
        switch(crtDevice.type.toLowerCase()){
        	case "blood pressure cuff":
        		bp_synced = true;
        		break;
        	case "scale":
        		scale_synced = true;
        		break;
        	case "tape measure":
        		tape_synced = true;
        		break;
        	case "pedometer":
        		pedometer_synched = true;
        		break;
        }
      }
    }
}

function setDeviceStatus(){
  // Default state
  $(".bp_status_icon").addClass("unsynced");
  $(".scale_status_icon").addClass("unsynced");
  $(".tape_status_icon").addClass("unsynced");
  $(".pedometer_status_icon").addClass("unsynced");
  $(".bp_status_str").addClass("red_caption");
  $(".scale_status_str").addClass("red_caption");
  $(".tape_status_str").addClass("red_caption");
  $(".pedometer_status_str").addClass("red_caption");
  $(".bp_status_str").html("Not Synced");
  $(".scale_status_str").html("Not Synced");
  $(".tape_status_str").html("Not Synced");
  $(".pedometer_status_str").html("Not Synced");
  // Blood pressure meter
  if(bp_synced){
  	$(".bp_status_icon").removeClass("unsynced");
  	$(".bp_status_icon").addClass("synced");
  	$(".bp_status_str").removeClass("red_caption");
  	$(".bp_status_str").addClass("green_caption");
  	$(".bp_status_str").html("Synced");
  }
  // Smart scale 
  if(scale_synced){
  	$(".scale_status_icon").removeClass("unsynced");
  	$(".scale_status_icon").addClass("synced");
  	$(".scale_status_str").removeClass("red_caption");
  	$(".scale_status_str").addClass("green_caption");
  	$(".scale_status_str").html("Synced");
  }
  // Digital tape
  if(tape_synced){
  	$(".tape_status_icon").removeClass("unsynced");
  	$(".tape_status_icon").addClass("synced");
  	$(".tape_status_str").removeClass("red_caption");
  	$(".tape_status_str").addClass("green_caption");
  	$(".tape_status_str").html("Synced");
  }
  // Pedometer
  if(pedometer_synched){
  	$(".pedometer_status_icon").removeClass("unsynced");
  	$(".pedometer_status_icon").addClass("synced");
  	$(".pedometer_status_str").removeClass("red_caption");
  	$(".pedometer_status_str").addClass("green_caption");
  	$(".pedometer_status_str").html("Synced");
  }  
}

function renderChart(dates, values, name, metric, chart_type){
	chart_type = 'graph_container_'+chart_type;
	if(dates && values){
		var chart;
		chart = new Highcharts.Chart({
	      chart: {
	        renderTo: chart_type,
	        type: 'area',
	        plotBackgroundColor: 'transparent',
	        backgroundColor: 'rgba(255, 255, 255, .45)',
	        borderRadius: '0'
	      },
	      title: {
	       text: '',
	     },
	    credits: {
	      enabled: false
	    },
	    legend: {
	    	enabled: false
	      // backgroundColor: 'transparent',
	      // borderWidth: '0'
	    },
	    exporting: {
	      buttons: {
	        printButton: {
	          enabled: false
	        },
	        exportButton: {
	          enabled: false
	        }
	      }
	    },
	    xAxis: {
	      categories: dates,
	      tickmarkPlacement: 'on',
	      labels: {
        	enabled: false
      	},
	      title: {
	        enabled: false
	      }
	    },
	    yAxis: {
	      title: {
	        text: metric
	      },
	      labels: {
	        formatter: function() {
	          return this.value;
	        }
	      }
	    },
	    tooltip: {
	      formatter: function() {
	        return ''+
	        this.x +': '+ Highcharts.numberFormat(this.y, 0, ',') + " " + metric;
	      }
	    },
	    plotOptions: {
	      series: {
        	enableMouseTracking: false
      	  },
	      area: {
	        lineColor: '#666',
	        fillOpacity: '.4',
	        lineWidth: 0,
	        marker: {
	          lineWidth: 0,
	          lineColor: '#666666'
	        }
	      }
	    },
	    series: [{
	      name: name,
	      data: values
	    }]
	  });
	} else {
		$("div#"+chart_type).html("No data available");
	}
}

function renderWeightChart(dates, values, name, metric, chart_type, goal_weight){
	chart_type = 'graph_container_'+chart_type;
	if(dates && values){
		goal_weight = parseInt(goal_weight);
		var chart;
		chart = new Highcharts.Chart({
	      chart: {
	        renderTo: chart_type,
	        type: 'area',
	        plotBackgroundColor: 'transparent',
	        backgroundColor: 'rgba(255, 255, 255, .45)',
	        borderRadius: '0'
	      },
	      title: {
	       text: '',
	     },
	    credits: {
	      enabled: false
	    },
	    legend: {
	    	enabled: false
	      // backgroundColor: 'transparent',
	      // borderWidth: '0'
	    },
	    exporting: {
	      buttons: {
	        printButton: {
	          enabled: false
	        },
	        exportButton: {
	          enabled: false
	        }
	      }
	    },
	    xAxis: {
	      categories: dates,
	      tickmarkPlacement: 'on',
	      labels: {
        	enabled: false
      	},
	      title: {
	        enabled: false
	      }
	    },
	    yAxis: {
	      min: (goal_weight - 15),
	      title: {
	        text: metric
	      },
	      labels: {
	        formatter: function() {
	          return this.value;
	        }
	      },
	      plotLines:[{
				value: goal_weight,
				width: 2,
				color: 'green'
			}]
	    },
	    tooltip: {
	      formatter: function() {
	        return ''+
	        this.x +': '+ Highcharts.numberFormat(this.y, 0, ',') + " " + metric;
	      }
	    },
	    plotOptions: {
	      series: {
        	enableMouseTracking: false
      	  },
	      area: {
	        lineColor: '#666',
	        fillOpacity: '.4',
	        lineWidth: 0,
	        marker: {
	          lineWidth: 0,
	          lineColor: '#666666'
	        }
	      }
	    },
	    series: [{
	      name: name,
	      data: values
	    }]
	  });
	} else {
		$("div#"+chart_type).html("No data available");
	}
}

function renderTable(arrayValues, dataName, metric, chart_type){
	if(arrayValues){
		arrayValues = arrayValues.reverse();
		var strHtml = "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">";
		strHtml += "<thead>";
		strHtml += "<tr><td>Date</td><td>"+dataName+"</td></tr>";
		strHtml += "</thead>";
		var tempValue = 0;
		for(var i = 0; i < arrayValues.length; i++){
			strHtml += "<tr>";
			strHtml += "<td>" + niceFormatDate(arrayValues[i][0]) + "</td>";
			strHtml += "<td>" + arrayValues[i][1] + " " + metric + "</td>";
			strHtml +=	"</tr>";
		
			tempValue = parseFloat(arrayValues[i][1]);
		}
		strHtml += "</table>";
		chart_type = "#table_container_"+chart_type;
		$(chart_type).html(strHtml);
	}	
}